Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/SubConstrRegist/FrmSubConstrRegistAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/SubConstrRegist/FrmSubConstrRegistAuxiliary.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/SubConstrRegist/FrmSubConstrRegistAuxiliary.cs	(revision 83)
@@ -0,0 +1,1664 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Collections;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using System.Drawing;
+
+using ProcessManagement.Forms.ControlsAction;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.Master;
+using ProcessManagement.DataModel;
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using System.Diagnostics;
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    partial class FrmSubConstrRegist
+    {
+
+        #region 表示オブジェクトの取得
+        /// <summary>
+        /// 表示オブジェクトの取得
+        /// </summary>
+        private void SetDisplayObject()
+        {
+            int DspCtrlCnt = Enum.GetNames(typeof(DispCtrl)).Length;
+            m_dispControl = new Control[DspCtrlCnt];
+
+            m_dispControl[(int)DispCtrl.EditMode] = lblEditMode;
+            m_dispControl[(int)DispCtrl.PersonCode] = label21;
+            m_dispControl[(int)DispCtrl.PersonName] = lblLabel01;
+            m_dispControl[(int)DispCtrl.DepartmentName] = lblLabel02;
+            m_dispControl[(int)DispCtrl.CreateDate] = lblLabel03;
+
+            m_dispControl[(int)DispCtrl.CorporateStatusName] = cmbCorporateStatus;
+            m_dispControl[(int)DispCtrl.CompanyName] = txtInput1;
+            m_dispControl[(int)DispCtrl.CEOPositionName] = txtInput2;
+            m_dispControl[(int)DispCtrl.CEOName] = txtInput3;
+            m_dispControl[(int)DispCtrl.ContactPersonName] = txtInput4;
+            m_dispControl[(int)DispCtrl.ZipCode] = txtInput5;
+            m_dispControl[(int)DispCtrl.Address1] = txtInput6;
+            m_dispControl[(int)DispCtrl.Address2] = txtInput7;
+            m_dispControl[(int)DispCtrl.Address3] = txtInput11;
+            m_dispControl[(int)DispCtrl.CellPhoneNumber] = txtInput12;
+            m_dispControl[(int)DispCtrl.MailAddress] = txtInput15;
+            m_dispControl[(int)DispCtrl.PhoneNumber] = txtInput8;
+            m_dispControl[(int)DispCtrl.JapaneseSyllabary] = txtInput13;
+            m_dispControl[(int)DispCtrl.FaxNumber] = txtInput9;
+            m_dispControl[(int)DispCtrl.StartDate] = txtInput14;
+            m_dispControl[(int)DispCtrl.Note] = txtInput10;
+            m_dispControl[(int)DispCtrl.EditMode] = lblEditMode;
+            m_dispControl[(int)DispCtrl.btnSerchZip] = btnSerchZip;
+            m_dispControl[(int)DispCtrl.PointNone] = rdbPoint1;
+            m_dispControl[(int)DispCtrl.PointFront] = rdbPoint2;
+            m_dispControl[(int)DispCtrl.PointRear] = rdbPoint3;
+            m_dispControl[(int)DispCtrl.GridJobItem] = dgvJobItem;
+            m_dispControl[(int)DispCtrl.btnJobItemAdd] = btnJobItemAdd;
+            m_dispControl[(int)DispCtrl.btnJobItemDelte] = btnJobItemDelete;
+            m_dispControl[(int)DispCtrl.PaymentNormal] = rdbPayment01;
+            m_dispControl[(int)DispCtrl.PaymentLabour] = rdbPayment02;
+
+            m_dispControl[(int)DispCtrl.OrderNo] = label26;
+            m_dispControl[(int)DispCtrl.OrderDate] = label27;
+        }
+        #endregion
+        
+        #region 画面ロック
+        /// <summary>
+        /// 画面ロック
+        /// </summary>
+        private void ControlLock(bool bctrl = true)
+        {
+            foreach (Control wrk in m_dispControl)
+            {
+                if (CommonMotions.chkObjectIsNull(wrk)) continue;
+                if (!wrk.GetType().Equals(typeof(Label)))
+                    wrk.Enabled = bctrl;
+            }
+        }
+        #endregion
+
+        #region 画面クリア
+        /// <summary>
+        /// 画面クリア
+        /// </summary>
+        private void ClearDisplay()
+        {
+            try
+            {
+                foreach (Control wrk in m_dispControl)
+                {
+                    if (CommonMotions.chkObjectIsNull(wrk)) continue;
+                    if (wrk.GetType().Equals(typeof(RadioButton))) continue;
+                    if (wrk.GetType().Equals(typeof(Button))) continue;
+                    wrk.Text = "";
+                }
+
+                cmbCorporateStatus.SelectedIndex = -1;
+                rdbPoint1.Checked = true;
+                m_bChengeAns = false;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 取引開始日チェック
+        /// <summary>
+        /// 取引開始日チェック
+        /// </summary>
+        /// <returns></returns>
+        private void ChkStartDate()
+        {
+            try
+            {
+                CommonMotions.chgBackColor(m_dispControl[(int)DispCtrl.StartDate], true);
+
+                if (!CommonMotions.DispFieldDateCheck(m_dispControl[(int)DispCtrl.StartDate], true))
+                {
+                    CommonMotions.chgBackColor(m_dispControl[(int)DispCtrl.StartDate], true);
+                    MessageBox.Show("日付の形式が誤っています。", "データ確認", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+                
+                DateTime dateStart = CommonMotions.cnvDate(m_dispControl[(int)DispCtrl.StartDate]);
+                if (dateStart.Date < DateTime.Today)
+                {
+                    CommonMotions.chgBackColor(m_dispControl[(int)DispCtrl.StartDate], true);
+                    if (MessageBox.Show("取引開始日が過去日付になっています。", "データ確認"
+                                        , MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) == DialogResult.Cancel) return;
+                }
+
+                CommonMotions.chgBackColor(m_dispControl[(int)DispCtrl.StartDate], true);
+           }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 画面項目のチェック
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            bool bRet = true;
+            int iLength = 0;
+            try
+            {
+                // 申請区分
+                panel3.BackColor = CommonDefine.s_clrNormal;
+                if (radioButton3.Checked)
+                {   // 修正時に元データが入っていない場合はエラー
+                    if (m_SourceCode == 0)
+                    {
+                        panel3.BackColor = CommonDefine.s_clrError;
+                        string strMsg = "変更元データが選択されていません。\n";
+                        strMsg += "「協力会社データ表示」ボタンをクリックして\n";
+                        strMsg += "変更元データを選択してください。";
+                        MessageBox.Show(strMsg, "データ確認", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                        return false;
+                    }
+                }
+
+                // 会社名１
+                if (m_dispControl[(int)DispCtrl.CompanyName].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.CompanyName], s_CompanyNameLength, true);
+
+                // 代表者役職名
+                if (m_dispControl[(int)DispCtrl.CEOPositionName].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.CEOPositionName], s_CEOPositionNameLength);
+
+                // 代表者氏名
+                if (m_dispControl[(int)DispCtrl.CEOName].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.CEOName], s_CEONameLength);
+
+                // 窓口担当者氏名
+                if (m_dispControl[(int)DispCtrl.ContactPersonName].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.ContactPersonName], s_CEONameLength);
+
+                // 住所１
+                if (m_dispControl[(int)DispCtrl.Address1].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.Address1], s_AddressLength, true);
+
+                // 住所２
+                if (m_dispControl[(int)DispCtrl.Address2].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.Address2], s_AddressLength);
+
+                // 住所３
+                if (m_dispControl[(int)DispCtrl.Address3].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.Address3], s_AddressLength);
+
+                // 郵便番号
+                if (m_dispControl[(int)DispCtrl.ZipCode].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldZipCodeCheck(m_dispControl[(int)DispCtrl.ZipCode], true);
+
+                // 携帯電話番号
+                if (m_dispControl[(int)DispCtrl.CellPhoneNumber].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldPhoneNumberCheck(m_dispControl[(int)DispCtrl.CellPhoneNumber], false);
+
+                // メールアドレス
+                if (m_dispControl[(int)DispCtrl.MailAddress].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldMailAddressCheck(m_dispControl[(int)DispCtrl.MailAddress], false);
+
+                // 電話番号
+                if (m_dispControl[(int)DispCtrl.PhoneNumber].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldPhoneNumberCheck(m_dispControl[(int)DispCtrl.PhoneNumber], true);
+
+                // FAX番号
+                if (m_dispControl[(int)DispCtrl.FaxNumber].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldPhoneNumberCheck(m_dispControl[(int)DispCtrl.FaxNumber]);
+
+                // 50音読み
+                if (m_dispControl[(int)DispCtrl.JapaneseSyllabary].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.JapaneseSyllabary], s_JapaneseSyllabaryLength);
+
+                // 取引開始年月
+                if (m_dispControl[(int)DispCtrl.StartDate].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldDateCheck(m_dispControl[(int)DispCtrl.StartDate], true);
+
+                // 備考
+                if (m_dispControl[(int)DispCtrl.Note].Text.Length != 0) iLength++;
+                bRet &= CommonMotions.DispFieldLengthCheck(m_dispControl[(int)DispCtrl.Note], s_NoteLength);
+
+                if (iLength == 0)
+                {
+                    MessageBox.Show("データが入力されていません、確認してください。", "データ確認", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                    return false;
+                }
+                if (!bRet)
+                {
+                    MessageBox.Show("入力エラーがあります、確認してください。", "データ確認", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                    return false;
+                }
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 初期時申請・承認表示処理
+        /// <summary>
+        /// 初期時申請・承認表示処理
+        /// </summary>
+        private void InitApprovalDisplay()
+        {
+            try
+            {
+                // 承認コード取得
+                int iApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+
+                // 起動元のリストに承認画面があれば表示しない
+                if (ClsApprovalPermission.ExceApprovalScreen((int)ClsExcute.SubFormExecuteNo.ApprovalPerson))
+                {
+                    pnlApproval.Visible = false;
+                }
+
+                // 承認ボタン・件数の非表示
+                btnApproval.Visible = false;
+                lblApprovalCount.Visible = false;
+
+                // ----- 初期時は申請ボタンのサイズを最大にする
+                btnPetition.Size = new Size(250, btnPetition.Size.Height);
+
+                DateTime OrderDate = CommonMotions.cnvDate(m_dispControl[(int)DispCtrl.OrderDate].Text);
+                int OrderNo = CommonMotions.cnvInt(m_dispControl[(int)DispCtrl.OrderNo].Text);
+                // ----- 担当者コード・承認機能番号取得（申請レコードがない場合は未申請）
+                if (!ClsApprovalPermission.CheckPersonPetition(m_PersonCode,
+                                                                iApprovalCode,
+                                                                OrderDate,
+                                                                OrderNo)) return;
+
+                // ----- 申請済の場合
+                // 申請ボタンの表示
+                btnPetition.Text = CommonDefine.PetitionButtonString[1];
+                btnPetition.ForeColor = Color.Black;
+                btnPetition.Size = btnApproval.Size;
+                btnPetition.Enabled = false;
+
+                // 承認ボタンの表示
+                btnApproval.Visible = true;
+
+                // ----- 承認済の場合
+                if (ClsApprovalPermission.CheckPersonApproval(m_PersonCode, iApprovalCode, OrderDate, OrderNo))
+                {
+                    btnApproval.Text = CommonDefine.ApprovalButtonString[1];
+                    btnApproval.ForeColor = Color.Black;
+                    // 承認済みの場合は入力できない
+                    ExecReadOnly();
+                    // 承認済みの場合は参照ロックを掛ける
+                    m_EditLock = true;
+                    //// 承認済みフラグON
+                    //m_ApprovalFlag = true;
+                }
+
+                // 承認件数の表示
+                lblApprovalCount.Visible = true;
+                SetApprovalCount();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 承認数表示
+        /// <summary>
+        /// 承認件数のセット
+        /// </summary>
+        private void SetApprovalCount()
+        {
+            try
+            {
+                // 初期値セット
+                lblApprovalCount.Text = "";
+
+                DateTime OrderDate = CommonMotions.cnvDate(m_dispControl[(int)DispCtrl.OrderDate].Text);
+                // 担当者コード・承認機能番号取得
+                int iApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                // 担当部署取得
+                int DepartmentCode = ClsApprovalPermission.GetFromPersonAndApprovalTheDepartment(m_PersonCode, iApprovalCode, OrderDate, 1);
+
+                // 承認データ取得
+                int ApprovalCount = ClsApprovalPermission.GetPersonApprovalDataCount(m_PersonCode, iApprovalCode, OrderDate);
+
+                // 承認経路マスタ取得
+                int MasterCount = ClsApprovalPermission.GetApprovalMasterCount(iApprovalCode, DepartmentCode);
+
+                // 初期値セット
+                lblApprovalCount.Text = string.Format("{0}/{1}", ApprovalCount, MasterCount);
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region データ登録時初期処理
+        /// <summary>
+        /// データ登録時初期処理
+        /// </summary>
+        /// <returns></returns>
+        private bool InitDataEntry(IOSubConstrRegist crDB, ref string strSQL, ref SubConstrRegist RegRec)
+        {
+            try
+            {
+                // 対象データ・取得SQL作成
+                if (m_NewData)
+                {   // 新規作成時
+                    // キー項目セット
+                    RegRec.PersonCode = CommonMotions.cnvInt(m_dispControl[(int)DispCtrl.PersonCode].Text);
+                    RegRec.CreateDate = CommonMotions.cnvDate(m_dispControl[(int)DispCtrl.CreateDate].Text);
+                    RegRec.PetitionPeriod = CommonMotions.SystemMasterData.BusinessPeriod;
+
+                    // 申請連番取得
+                    strSQL = crDB.CreatePrimarykeyString(RegRec.PersonCode, RegRec.CreateDate);
+                    int SeqNo = crDB.SelectMaxSeqNoCount(strSQL, false) + 1;
+                    strSQL = crDB.CreatePrimarykeyString(RegRec.PersonCode, RegRec.CreateDate, SeqNo);
+                    crDB.DeleteAction(strSQL, false);
+
+                    RegRec.SeqNo = SeqNo;
+                    m_PersonCode = RegRec.PersonCode;
+                    m_CreateDate = RegRec.CreateDate;
+                    m_SeqNo = SeqNo;
+                }
+                else
+                {   //  既存データ取得
+                    strSQL = crDB.CreatePrimarykeyString(m_PersonCode, m_CreateDate, m_SeqNo);
+                    if (!crDB.SelectAction(strSQL, ref RegRec, false))
+                    {
+                        crDB.rollback();
+                        MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 協力業者登録申請データ登録
+        /// <summary>
+        /// 協力業者登録申請データ登録
+        /// </summary>
+        private bool SubConstrRegistDataEntry()
+        {
+            IOSubConstrRegist sbDB = new IOSubConstrRegist();
+            IOSubConstrJobItemRegist jobitemDB = new IOSubConstrJobItemRegist();
+            IOSubConstrJobLinkRegist joblinkDB = new IOSubConstrJobLinkRegist();
+            try
+            {
+                //データチェック
+                if (!DispFeildCheck()) return false;
+
+                // 一括処理なので接続を行う
+                sbDB.connect(); sbDB.beginTran();
+                jobitemDB.connect(); jobitemDB.beginTran();
+                joblinkDB.connect(); joblinkDB.beginTran();
+
+                SubConstrRegist RegRec = new SubConstrRegist();
+                List<SubConstrRegist> workList = new List<SubConstrRegist>();
+                string strSQL = string.Empty;
+
+                // データ登録時初期処理
+                if (!InitDataEntry(sbDB, ref strSQL, ref RegRec)) return false;
+
+                // 申請区分
+                if (radioButton4.Checked)
+                    RegRec.DataMode = (int)DataMode.NewData;
+                else
+                    RegRec.DataMode = (int)DataMode.EditData;
+
+                // 法人格名称位置
+                if (rdbPoint1.Checked == true) RegRec.CorporateStatusPoint = (int)CommonDefine.StatusNamePoint.None;
+                else if (rdbPoint2.Checked == true) RegRec.CorporateStatusPoint = (int)CommonDefine.StatusNamePoint.Forword;
+                else if (rdbPoint3.Checked == true) RegRec.CorporateStatusPoint = (int)CommonDefine.StatusNamePoint.Back;
+
+                // 法人格名称
+                if (RegRec.CorporateStatusPoint != 0)
+                    if (m_dispControl[(int)DispCtrl.CorporateStatusName].Text.Length != 0)
+                        RegRec.CorporateStatusName = m_dispControl[(int)DispCtrl.CorporateStatusName].Text;
+
+                // 会社名
+                if (m_dispControl[(int)DispCtrl.CompanyName].Text.Length != 0)
+                    RegRec.CompanyName = m_dispControl[(int)DispCtrl.CompanyName].Text;
+
+                // 役職名
+                if (m_dispControl[(int)DispCtrl.CEOPositionName].Text.Length != 0)
+                    RegRec.CEOPositionName = m_dispControl[(int)DispCtrl.CEOPositionName].Text;
+
+                // 代表者名
+                if (m_dispControl[(int)DispCtrl.CEOName].Text.Length != 0)
+                    RegRec.CEOName = m_dispControl[(int)DispCtrl.CEOName].Text;
+
+                // 窓口担当者名
+                if (m_dispControl[(int)DispCtrl.ContactPersonName].Text.Length != 0)
+                    RegRec.ContactPersonName = m_dispControl[(int)DispCtrl.ContactPersonName].Text;
+
+                // 郵便番号
+                if (m_dispControl[(int)DispCtrl.ZipCode].Text.Length != 0)
+                    RegRec.ZipCode = m_dispControl[(int)DispCtrl.ZipCode].Text;
+
+                // 住所１
+                if (m_dispControl[(int)DispCtrl.Address1].Text.Length != 0)
+                    RegRec.Address1 = m_dispControl[(int)DispCtrl.Address1].Text;
+
+                // 住所２
+                if (m_dispControl[(int)DispCtrl.Address2].Text.Length != 0)
+                    RegRec.Address2 = m_dispControl[(int)DispCtrl.Address2].Text;
+
+                // 住所３
+                if (m_dispControl[(int)DispCtrl.Address3].Text.Length != 0)
+                    RegRec.Address3 = m_dispControl[(int)DispCtrl.Address3].Text;
+
+                // 携帯電話番号
+                if (m_dispControl[(int)DispCtrl.CellPhoneNumber].Text.Length != 0)
+                    RegRec.CellPhoneNumber = m_dispControl[(int)DispCtrl.CellPhoneNumber].Text;
+
+                // メールアドレス
+                if (m_dispControl[(int)DispCtrl.MailAddress].Text.Length != 0)
+                    RegRec.MailAddress = m_dispControl[(int)DispCtrl.MailAddress].Text;
+
+                // 電話番号
+                if (m_dispControl[(int)DispCtrl.PhoneNumber].Text.Length != 0)
+                    RegRec.PhoneNumber = m_dispControl[(int)DispCtrl.PhoneNumber].Text;
+
+                // FAX番号
+                if (m_dispControl[(int)DispCtrl.FaxNumber].Text.Length != 0)
+                    RegRec.FaxNumber = m_dispControl[(int)DispCtrl.FaxNumber].Text;
+
+                // 50音読み
+                if (m_dispControl[(int)DispCtrl.JapaneseSyllabary].Text.Length != 0)
+                    RegRec.JapaneseSyllabary = m_dispControl[(int)DispCtrl.JapaneseSyllabary].Text;
+
+                // 登録日
+                if (m_dispControl[(int)DispCtrl.StartDate].Text.Length != 0)
+                    RegRec.StartDate = CommonMotions.cnvUndecidedStringToDate(m_dispControl[(int)DispCtrl.StartDate].Text);
+
+                // 備考
+                if (m_dispControl[(int)DispCtrl.Note].Text.Length != 0)
+                    RegRec.Note = m_dispControl[(int)DispCtrl.Note].Text;
+
+                // 支払業者区分
+                if (rdbPayment01.Checked == true) RegRec.labourKind = (int)CommonDefine.SubContractorPaymentKind.Normal;
+                else if (rdbPayment02.Checked == true) RegRec.labourKind = (int)CommonDefine.SubContractorPaymentKind.Labor;
+
+                // 協力会社コード
+                RegRec.SourceCode = m_SourceCode;
+                
+                if (NewData)
+                {
+                    // データ登録
+                    if (!sbDB.InsertAction(RegRec, false))
+                    {
+                        sbDB.rollback();
+                        MessageBox.Show("協力業者登録申請データ登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+                else
+                {
+                    // データ更新
+                    if (!sbDB.UpdateAction(strSQL, RegRec, false))
+                    {
+                        sbDB.rollback();
+                        MessageBox.Show("協力業者登録申請データ更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+
+                // 工種登録処理を行う
+                if (!SubContractorItemMasterDataEntry(jobitemDB, RegRec))
+                {
+                    sbDB.rollback();
+                    jobitemDB.rollback();
+                    MessageBox.Show("工種登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                // 職種登録処理を行う
+                if (!SubContractorJobLinkDataEntry(joblinkDB, RegRec))
+                {
+                    sbDB.rollback();
+                    jobitemDB.rollback();
+                    joblinkDB.rollback();
+                    MessageBox.Show("職種登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.commit(); sbDB.close(); sbDB = null;
+                jobitemDB.commit(); jobitemDB.close(); jobitemDB = null;
+                joblinkDB.commit(); joblinkDB.close(); joblinkDB = null;
+            }
+        }
+        #endregion
+
+        #region 協力会社施工工種データ登録
+        /// <summary>
+        /// 協力会社施工工種データ登録
+        /// </summary>
+        /// <param name="jobitemDB"></param>
+        /// <returns></returns>
+        private bool SubContractorItemMasterDataEntry(IOSubConstrJobItemRegist jobitemDB, SubConstrRegist RegRec)
+        {
+            try
+            {
+                string strDel = jobitemDB.CreatePrimarykeyString(RegRec.PersonCode, RegRec.CreateDate, RegRec.SeqNo);
+                jobitemDB.DeleteAction(strDel, false);
+
+                int ijobCnt = 0;
+                foreach (DataGridViewRow wrkRow in dgvJobItem.Rows)
+                {
+                    if (CommonMotions.chkCellBlank(wrkRow.Cells[0].Value)) continue;
+                    ijobCnt++;
+                }
+                if (ijobCnt == 0) return true;
+
+                string subSQL = string.Empty;
+                ijobCnt = 1;
+                foreach (DataGridViewRow wrkRow in dgvJobItem.Rows)
+                {
+                    if (CommonMotions.chkCellBlank(wrkRow.Cells[0].Value)) continue;
+
+                    if (ijobCnt == 1) subSQL += " (";
+                    else subSQL += ", (";
+
+                    subSQL += string.Format(" {0}", RegRec.PersonCode);
+                    subSQL += string.Format(", STR_TO_DATE('{0}','%Y/%m/%d')", RegRec.CreateDate.ToShortDateString());
+                    subSQL += string.Format(", {0}", RegRec.SeqNo);
+                    subSQL += string.Format(", {0}", ijobCnt++);
+                    subSQL += string.Format(", {0}", CommonMotions.cnvInt(wrkRow.Cells[0].Value));
+                    subSQL += ", NOW()";
+                    subSQL += ", NOW()";
+                    subSQL += ")";
+
+                }
+                if (subSQL.Length == 0) return true;
+
+                string strSQL = "INSERT SubConstrJobItemRegist";
+                strSQL += " (";
+                bool bFirst = true;
+                foreach (var gender in Enum.GetValues(typeof(IOSubConstrJobItemRegist.TableColumn)))
+                {
+                    if (!bFirst) strSQL += " ,";
+                    strSQL += gender.ToString();
+                    bFirst = false;
+                }
+                strSQL += ") VALUES";
+
+                strSQL += subSQL;
+                if (!jobitemDB.ExecuteNonQuery(strSQL, false)) return false;
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 協力会社施工職種データ登録
+        /// <summary>
+        /// 協力会社施工職種データ登録
+        /// </summary>
+        /// <param name="jobLinkDB"></param>
+        /// <returns></returns>
+        private bool SubContractorJobLinkDataEntry(IOSubConstrJobLinkRegist jobLinkDB, SubConstrRegist RegRec)
+        {
+            try
+            {
+                string strDel = jobLinkDB.CreatePrimarykeyString(RegRec.PersonCode, RegRec.CreateDate, RegRec.SeqNo);
+                jobLinkDB.DeleteAction(strDel, false);
+
+                int ijobCnt = 0;
+                foreach (DataGridViewRow wrkRow in dgvJobLink.Rows)
+                {
+                    if (CommonMotions.chkCellBlank(wrkRow.Cells[0].Value)) continue;
+                    ijobCnt++;
+                }
+                if (ijobCnt == 0) return true;
+
+                string subSQL = string.Empty;
+                ijobCnt = 1;
+                foreach (DataGridViewRow wrkRow in dgvJobLink.Rows)
+                {
+                    if (CommonMotions.chkCellBlank(wrkRow.Cells[0].Value)) continue;
+
+                    if (ijobCnt == 1) subSQL += " (";
+                    else subSQL += ", (";
+
+                    subSQL += string.Format(" {0}", RegRec.PersonCode);
+                    subSQL += string.Format(", STR_TO_DATE('{0}','%Y/%m/%d')", RegRec.CreateDate.ToShortDateString());
+                    subSQL += string.Format(", {0}", RegRec.SeqNo);
+                    subSQL += string.Format(", {0}", ijobCnt++);
+                    subSQL += string.Format(", {0}", CommonMotions.cnvInt(wrkRow.Cells[0].Value));
+                    subSQL += ", NOW()";
+                    subSQL += ", NOW()";
+                    subSQL += ")";
+
+                }
+                
+                if (subSQL.Length == 0) return true;
+
+                string strSQL = "INSERT SubConstrJobLinkRegist";
+                strSQL += " (";
+                bool bFirst = true;
+                foreach (var gender in Enum.GetValues(typeof(IOSubConstrJobLinkRegist.TableColumn)))
+                {
+                    if (!bFirst) strSQL += " ,";
+                    strSQL += gender.ToString();
+                    bFirst = false;
+                }
+                strSQL += ") VALUES";
+                strSQL += subSQL;
+                if (!jobLinkDB.ExecuteNonQuery(strSQL, false)) return false;
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 協力業者登録申請データ削除
+        /// <summary>
+        /// 協力業者登録申請データ削除
+        /// </summary>
+        /// <returns></returns>
+        private bool SubConstrRegistDataRemove()
+        {
+            IOSubConstrRegist crDB = new IOSubConstrRegist();
+            IOSubConstrJobItemRegist ItemDB = new IOSubConstrJobItemRegist();
+            IOSubConstrJobLinkRegist LinkDB = new IOSubConstrJobLinkRegist();
+            try
+            {
+                if (m_NewData) return true;
+
+                crDB.connect(); crDB.beginTran();
+                ItemDB.connect(); ItemDB.beginTran();
+                LinkDB.connect(); LinkDB.beginTran();
+
+                string strWhere = crDB.CreatePrimarykeyString(m_PersonCode, m_CreateDate, m_SeqNo);
+
+                if (!crDB.DeleteAction(strWhere,false))
+                {
+                    crDB.rollback();
+                    MessageBox.Show("協力業者登録申請データ削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                // 以下２テーブルは無いかもしれないのでエラーを取らない
+                ItemDB.DeleteAction(strWhere, false);
+                LinkDB.DeleteAction(strWhere, false);
+
+                crDB.commit();
+                ItemDB.commit();
+                LinkDB.commit();
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                crDB.close(); crDB = null;
+                ItemDB.close(); ItemDB = null;
+                LinkDB.close(); LinkDB = null;
+            }
+        }
+        #endregion
+
+        #region ヘッダー情報表示
+        /// <summary>
+        /// ヘッダー情報表示
+        /// </summary>
+        private void DispHeader()
+        {
+            IOMDepartment dmDB = new IOMDepartment();
+            try
+            {
+                string strSQL = "SELECT B.DEPARTMENTSTRING, A.PERSONNAME FROM PERSONINCHARGEMASTER A, DEPARTMENTMASTER B";
+                strSQL += string.Format(" WHERE A.PERSONCODE = {0}", m_PersonCode);
+                strSQL += " AND B.DEPARTMENTCODE = A.DEPARTMENTCODE";
+                ArrayList dmRec = new ArrayList();
+                dmDB.ExecuteReader(strSQL, ref dmRec);
+
+                string strDepName = string.Empty;
+                string strPerName = string.Empty;
+                m_dispControl[(int)DispCtrl.EditMode].Text = CommonDefine.EditModeStringNew + s_FixTitle;
+                if (dmRec.Count != 0)
+                {
+                    object[] objRec = (object[])dmRec[0];
+                    strDepName = CommonMotions.cnvString(objRec[0]);
+                    strPerName = CommonMotions.cnvString(objRec[1]);
+                    m_dispControl[(int)DispCtrl.EditMode].Text = CommonDefine.EditModeStringEdit + s_FixTitle;
+                }
+
+                m_dispControl[(int)DispCtrl.PersonCode].Text = m_PersonCode.ToString();
+                m_dispControl[(int)DispCtrl.PersonName].Text = strPerName;
+                m_dispControl[(int)DispCtrl.DepartmentName].Text = strDepName;
+                m_dispControl[(int)DispCtrl.CreateDate].Text = DateTime.Now.ToShortDateString();
+                m_dispControl[(int)DispCtrl.StartDate].Text = DateTime.Now.ToShortDateString();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                dmDB.close(); dmDB = null;
+            }
+        }
+        #endregion
+
+        #region 協力業者登録申請データ表示処理
+        /// <summary>
+        /// 協力業者登録申請データ表示処理
+        /// </summary>
+        /// <returns></returns>
+        private bool DispMentenanceData()
+        {
+            IOSubConstrRegist crDB = new IOSubConstrRegist();                       // 協力業者登録申請データ
+            try
+            {
+                // 協力会社マスタ取得
+                ArrayList crList = new ArrayList();
+                string strSQL = "SELECT A.*, B.PERSONNAME, C.DEPARTMENTSTRING, C.DEPARTMENTCODE FROM SUBCONSTRREGIST A";
+                strSQL += " LEFT JOIN PERSONINCHARGEMASTER B ON B.PERSONCODE = A.PERSONCODE";
+                strSQL += " LEFT JOIN DEPARTMENTMASTER C ON C.DEPARTMENTCODE = B.DEPARTMENTCODE";
+                strSQL += string.Format(" WHERE A.PersonCode = {0}", m_PersonCode);
+                strSQL += string.Format(" AND A.CreateDate = STR_TO_DATE('{0}','%Y/%m/%d')", m_CreateDate.ToShortDateString());
+                strSQL += string.Format(" AND A.SeqNo = {0}", m_SeqNo);
+
+                if (!crDB.ExecuteReader(strSQL, ref crList)) return false;
+                if (crList.Count == 0) return true;
+
+                object[] crRec = (object[])crList[0];
+                // データ表示
+
+                m_SourceCode = CommonMotions.cnvInt(crRec[(int)IOSubConstrRegist.TableColumn.SourceCode]);
+                string strEdit = string.Empty;
+                int datamode = CommonMotions.cnvInt(crRec[(int)IOSubConstrRegist.TableColumn.DataMode]);
+                if (datamode == (int)DataMode.NewData)
+                {
+                    strEdit = CommonDefine.EditModeStringNew;
+                    radioButton4.Checked = true;
+                }
+                else
+                {
+                    strEdit = CommonDefine.EditModeStringEdit;
+                    radioButton3.Checked = true;
+                }
+
+                m_dispControl[(int)DispCtrl.EditMode].Text = string.Format("{0}{1}", strEdit, s_FixTitle);
+
+                int StatusPoint = CommonMotions.cnvInt(crRec[(int)IOSubConstrRegist.TableColumn.CorporateStatusPoint]);    // 法人格名称表示位置
+                if (StatusPoint == 0) rdbPoint1.Checked = true;
+                else if (StatusPoint == 1) rdbPoint2.Checked = true;
+                else if (StatusPoint == 2) rdbPoint3.Checked = true;
+                m_dispControl[(int)DispCtrl.CorporateStatusName].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.CorporateStatusName]); // 法人格名称
+
+                m_dispControl[(int)DispCtrl.OrderNo].Text = CommonMotions.cnvInt(crRec[(int)IOSubConstrRegist.TableColumn.OrderNo]).ToString();
+                m_dispControl[(int)DispCtrl.OrderDate].Text = CommonMotions.cnvDate(crRec[(int)IOSubConstrRegist.TableColumn.OrderDate]).ToShortDateString();
+
+                m_dispControl[(int)DispCtrl.CompanyName].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.CompanyName]);                 // 会社名１
+                m_dispControl[(int)DispCtrl.CEOPositionName].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.CEOPositionName]);         // 役職名
+                m_dispControl[(int)DispCtrl.CEOName].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.CEOName]);                         // 代表者氏名
+                m_dispControl[(int)DispCtrl.ContactPersonName].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.ContactPersonName]);     // 窓口担当者
+                m_dispControl[(int)DispCtrl.ZipCode].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.ZipCode]);                         // 郵便番号
+                m_dispControl[(int)DispCtrl.Address1].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.Address1]);                       // 住所１
+                m_dispControl[(int)DispCtrl.Address2].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.Address2]);                       // 住所２
+                m_dispControl[(int)DispCtrl.Address3].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.Address3]);                       // 住所３
+                m_dispControl[(int)DispCtrl.CellPhoneNumber].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.CellPhoneNumber]);         // 携帯電話番号
+                m_dispControl[(int)DispCtrl.MailAddress].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.MailAddress]);                 // メールアドレス
+                m_dispControl[(int)DispCtrl.PhoneNumber].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.PhoneNumber]);                 // 電話番号
+                m_dispControl[(int)DispCtrl.FaxNumber].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.FaxNumber]);                     // FAX番号
+                m_dispControl[(int)DispCtrl.JapaneseSyllabary].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.JapaneseSyllabary]);     // 50音読み
+                m_dispControl[(int)DispCtrl.StartDate].Text = CommonMotions.cnvDate(crRec[(int)IOSubConstrRegist.TableColumn.StartDate]).ToShortDateString();   // 見積提出日
+                m_dispControl[(int)DispCtrl.Note].Text = CommonMotions.cnvString(crRec[(int)IOSubConstrRegist.TableColumn.Note]);                               // 備考
+
+                int labourkind = CommonMotions.cnvInt(crRec[(int)IOSubConstrRegist.TableColumn.labourKind]);                    // 業者支払区分（通常・手間）
+                switch (labourkind)
+                {
+                    case (int)CommonDefine.SubContractorPaymentKind.Normal:
+                        rdbPayment01.Checked = true;
+                        break;
+                    case (int)CommonDefine.SubContractorPaymentKind.Labor:
+                        rdbPayment02.Checked = true;
+                        break;
+                }
+
+                int DspCtrlCnt = Enum.GetNames(typeof(IOSubConstrRegist.TableColumn)).Length;
+                m_dispControl[(int)DispCtrl.PersonName].Text = CommonMotions.cnvString(crRec[DspCtrlCnt]);
+                m_dispControl[(int)DispCtrl.DepartmentName].Text = CommonMotions.cnvString(crRec[(DspCtrlCnt + 1)]);
+
+                m_dispControl[(int)DispCtrl.CreateDate].Text = CommonMotions.cnvDate(crRec[(int)IOSubConstrRegist.TableColumn.CreateDate]).ToShortDateString();
+                m_dispControl[(int)DispCtrl.PersonCode].Text = CommonMotions.cnvInt(crRec[(int)IOSubConstrRegist.TableColumn.PersonCode]).ToString();
+
+                // 申請データキー取得
+                m_CreateDate = CommonMotions.cnvDate(crRec[(int)IOSubConstrRegist.TableColumn.CreateDate]);
+                m_SeqNo = CommonMotions.cnvInt(crRec[(int)IOSubConstrRegist.TableColumn.SeqNo]);
+
+                // 協力会社工種データ表示
+                DspJobItemGrid(m_PersonCode, m_CreateDate, m_SeqNo);
+                // 協力会社職種データ表示
+                DspdgvJobLinkGrid(m_PersonCode, m_CreateDate, m_SeqNo);
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                crDB.close(); crDB = null;
+                if (dgvJobItem.RowCount < 4) dgvJobItem.RowCount += (4 - dgvJobItem.RowCount);
+                if (dgvJobLink.RowCount < 4) dgvJobLink.RowCount += (4 - dgvJobLink.RowCount);
+            }
+        }
+        #endregion
+
+        #region 協力会社工種データ表示
+        /// <summary>
+        /// 協力会社工種データ表示
+        /// </summary>
+        private void DspJobItemGrid(int PersonCode, DateTime CreateDate, int SeqNo, bool bDefault = true)
+        {
+            IOSubConstrJobItemRegist jobItemDB = new IOSubConstrJobItemRegist();    // 協力会社工種関連マスタクラス
+            try
+            {
+                dgvJobItem.Rows.Clear();
+                // ----- 協力会社工種データ表示
+                string ItemSQL = string.Empty;
+                int CodeCnt = 0;
+                int ItemCnt = 0;
+                if (bDefault)
+                {
+                    ItemSQL = "SELECT A.*, B.ITEMNAME FROM SUBCONSTRJOBITEMREGIST A, SUBCONTRACTORITEMMASTER B";
+                    ItemSQL += jobItemDB.CreatePrimarykeyString(PersonCode, CreateDate, SeqNo, 0, "A");
+
+                    CodeCnt = (int)IOSubConstrJobItemRegist.TableColumn.ItemCode;
+                    ItemCnt = Enum.GetNames(typeof(IOSubConstrJobItemRegist.TableColumn)).Length;
+                }
+                else
+                {
+                    ItemSQL = "SELECT A.*, B.ITEMNAME FROM SUBCONTRACTORJOBITEM A, SUBCONTRACTORITEMMASTER B";
+                    ItemSQL += string.Format(" WHERE A.COMPANYCODE = {0}", PersonCode);
+
+                    CodeCnt = (int)IOMSubContractorJobItem.NameColumn.ItemCode;
+                    ItemCnt = Enum.GetNames(typeof(IOMSubContractorJobItem.NameColumn)).Length;
+                }
+                ItemSQL += " AND B.ITEMCODE = A.ITEMCODE";
+                ItemSQL += " ORDER BY A.DISPLAYORDER";
+
+                ArrayList JobItemList = new ArrayList();
+                if (!jobItemDB.ExecuteReader(ItemSQL, ref JobItemList)) return;
+
+                foreach (object[] wrkRec in JobItemList)
+                {
+                    dgvJobItem.Rows.Add(CommonMotions.cnvString(wrkRec[CodeCnt]),
+                                        CommonMotions.cnvString(wrkRec[ItemCnt]));
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (dgvJobItem.RowCount < 4) dgvJobItem.RowCount += (4 - dgvJobItem.RowCount);
+                jobItemDB.close(); jobItemDB = null;
+            }
+        }
+        #endregion
+
+        #region 協力会社職種データ表示
+        /// <summary>
+        /// 協力会社職種データ表示
+        /// </summary>
+        private void DspdgvJobLinkGrid(int PersonCode, DateTime CreateDate, int SeqNo, bool bDefault = true)
+        {
+            IOSubConstrJobLinkRegist jobLinkDB = new IOSubConstrJobLinkRegist();    // 協力会社職種関連マスタクラス
+            try
+            {
+                dgvJobLink.Rows.Clear();
+                // ----- 協力会社職種データ表示
+                string jobSQL = string.Empty;
+                int CodeCnt = 0;
+                int JobCnt = 0;
+                if (bDefault)
+                {
+                    jobSQL = "SELECT A.*, B.JOBCATEGORYNAME FROM SUBCONSTRJOBLINKREGIST A, SUBCONTRACTORJOBCATEGORY B";
+                    jobSQL += jobLinkDB.CreatePrimarykeyString(PersonCode, CreateDate, SeqNo, 0, "A");
+
+                    CodeCnt = (int)IOSubConstrJobLinkRegist.TableColumn.JobCategoryCode;
+                    JobCnt = Enum.GetNames(typeof(IOSubConstrJobLinkRegist.TableColumn)).Length;
+                }
+                else
+                {
+                    jobSQL = "SELECT A.*, B.JOBCATEGORYNAME FROM SUBCONTRACTORJOBLINK A, SUBCONTRACTORJOBCATEGORY B";
+                    jobSQL += string.Format(" WHERE A.COMPANYCODE = {0}", PersonCode);
+
+                    CodeCnt = (int)IOMSubContractorJobLink.NameColumn.JobCategoryCode;
+                    JobCnt = Enum.GetNames(typeof(IOMSubContractorJobLink.NameColumn)).Length;
+                }
+                jobSQL += " AND B.JOBCATEGORYCODE = A.JOBCATEGORYCODE";
+                jobSQL += " ORDER BY A.DISPLAYORDER";
+
+                ArrayList jobLinkList = new ArrayList();
+                if (!jobLinkDB.ExecuteReader(jobSQL, ref jobLinkList)) return;
+                foreach (object[] wrkRec in jobLinkList)
+                {
+                    dgvJobLink.Rows.Add(CommonMotions.cnvString(wrkRec[CodeCnt]),
+                                        CommonMotions.cnvString(wrkRec[JobCnt]));
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                jobLinkDB.close(); jobLinkDB = null;
+                if (dgvJobLink.RowCount < 4) dgvJobLink.RowCount += (4 - dgvJobLink.RowCount);
+            }
+        }
+        #endregion
+
+        #region 法人格コンボボックスセット
+        /// <summary>
+        /// 法人格コンボボックスセット
+        /// </summary>
+        private void SetcmbCorporateStatusCombBox()
+        {
+            IOMBusinessType btDB = new IOMBusinessType();
+            try
+            {
+                cmbCorporateStatus.DataSource = null;
+                cmbCorporateStatus.Items.Clear();
+
+                List<BusinessTypeMaster> btList = new List<BusinessTypeMaster>();
+                if (!btDB.SelectAction(" ORDER BY DISPLAYORDER", ref btList)) return;
+                if (btList.Count == 0) return;
+
+                List<KeyValuePair<int, string>> DataList = new List<KeyValuePair<int, string>>();
+                // データ表示
+                for (int i = 0; i < btList.Count; i++)
+                {
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(btList[i].DisplayOrder, btList[i].BusinessTypeName);
+
+                    DataList.Add(keyval);
+                }
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbCorporateStatus, DataList);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                btDB.close(); btDB = null;
+            }
+        }
+        #endregion
+
+        #region 参照時ロック処理
+        /// <summary>
+        /// 参照時ロック処理
+        /// </summary>
+        private void ExecReadOnly()
+        {
+            try
+            {
+                ControlLock(false);
+                btnDataEntry.Visible = false;
+                btnDataDelete.Visible = false;
+                btnJobItemAdd.Visible = false;
+                btnJobItemDelete.Visible = false;
+                btnJobItemDown.Visible = false;
+                btnJobItemUp.Visible = false;
+                btnJobLinkAdd.Visible = false;
+                btnJobLinkDelete.Visible = false;
+                btnJobLinkDown.Visible = false;
+                btnJobLinkUp.Visible = false;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 申請区分変更時処理
+        /// <summary>
+        /// 申請区分変更時処理
+        /// </summary>
+        private void DataModeChange()
+        {
+            try
+            {
+                string strMode = string.Empty;
+                if (radioButton4.Checked)
+                {
+                    strMode = string.Format("{0}{1}", CommonDefine.EditModeStringNew, s_FixTitle);
+                    m_SourceCode = 0;
+                }
+                else
+                {
+                    strMode = string.Format("{0}{1}", CommonDefine.EditModeStringEdit, s_FixTitle);
+                }
+                m_dispControl[(int)DispCtrl.EditMode].Text = strMode;
+                
+                m_bChengeAns = true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 申請ボタン押下処理
+        /// <summary>
+        /// 申請ボタン押下処理
+        /// </summary>
+        private void PetitionProcess()
+        {
+            IOSubConstrRegist CrDB = new IOSubConstrRegist();
+            IOPersonApproval PersonAppDB = new IOPersonApproval();
+            try
+            {
+                // 協力業者登録申請データが無い場合は登録する
+                string strSQL = CrDB.CreatePrimarykeyString(m_PersonCode, m_CreateDate, m_SeqNo);
+                SubConstrRegist DataRec = new SubConstrRegist();
+                if (!CrDB.SelectAction(strSQL, ref DataRec)) m_bChengeAns = true;
+
+                // データ変更有時はデータ登録
+                if (m_bChengeAns) if (!SubConstrRegistDataEntry()) return;
+
+                // 一気にメニューに戻る
+                m_EndButton = true;
+                ClsExcute.ClearProcess();
+
+                DateTime wkDate = DateTime.Now;
+                // 起動番号
+                int NowPoint = ClsExcute.NextProcess((int)ClsExcute.SubFormExecuteNo.ApprovalPerson);
+                // 担当者コード
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(m_PersonCode);
+                // 承認機能番号
+                int iApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(iApprovalCode);
+                // 受付日
+                ClsExcute.ProcControlPara[NowPoint].DateExecParameter.Add(wkDate);
+                // 受付番号
+                string strApp = PersonAppDB.CreatePrimarykeyString(m_PersonCode, (int)ClsExcute.ApprovalListNo.SubConstregistApproval, wkDate);
+                int wrkOrderNo = PersonAppDB.SelectMaxOrderNoCount(strApp) + 1;
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(wrkOrderNo);
+
+                // 検索日付キー
+                ClsExcute.ProcControlPara[NowPoint].DateExecParameter.Add(m_CreateDate);
+                // 検索連番キー
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(m_SeqNo);
+
+                // 親フォーム終了
+                m_ParentEnd = true;
+
+                // 自フォーム終了
+                this.Close();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                CrDB.close(); CrDB = null;
+                PersonAppDB.close(); PersonAppDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認ボタン押下処理
+        /// <summary>
+        /// 承認ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void ApprovalProcess()
+        {
+            try
+            {
+                // データ変更有時はデータ登録
+                if (m_bChengeAns)
+                {
+                    if (!SubConstrRegistDataEntry()) return;
+                }
+
+                // 一気にメニューに戻る
+                m_EndButton = true;
+                ClsExcute.ClearProcess();
+
+                // 起動番号
+                int NowPoint = ClsExcute.NextProcess((int)ClsExcute.SubFormExecuteNo.ApprovalPerson);
+
+                // 担当者コード
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(m_PersonCode);
+
+                // 承認機能番号
+                int iApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(iApprovalCode);
+
+                // 受付日
+                string strartDate = m_dispControl[(int)DispCtrl.OrderDate].Text;
+                ClsExcute.ProcControlPara[NowPoint].DateExecParameter.Add(CommonMotions.cnvDate(strartDate));
+
+                // 受付番号
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(CommonMotions.cnvInt(m_dispControl[(int)DispCtrl.OrderNo].Text));
+
+                // 検索日付キー
+                ClsExcute.ProcControlPara[NowPoint].DateExecParameter.Add(m_CreateDate);
+                // 検索連番キー
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(m_SeqNo);
+
+                // 親フォーム終了
+                m_ParentEnd = true;
+
+                // 自フォーム終了
+                this.Close();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 承認パネル（pnlApproval）承認ボタン押下処理
+        /// <summary>
+        /// 承認パネル（pnlApproval）承認ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void OnApprovalProcess()
+        {
+            FrmApprovalPerson frm = new FrmApprovalPerson();
+            try
+            {
+                if (MessageBox.Show("協力会社申請登録を承認します、よろしいですか？。", "承認確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.No) return;
+
+                // 一気にメニューに戻る
+                m_EndButton = true;
+                ClsExcute.ClearProcess();
+
+                // 担当者コード
+                frm.PersonCode = m_PersonCode;
+                // 承認機能番号セット
+                frm.ApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                // 受付日
+                string strartDate = m_dispControl[(int)DispCtrl.OrderDate].Text;
+                frm.OrderDate = CommonMotions.cnvDate(strartDate);
+                // 受付番号
+                frm.OrderNo = CommonMotions.cnvInt(m_dispControl[(int)DispCtrl.OrderNo].Text);
+
+                // 検索日付キー
+                frm.DataSearchDate = m_CreateDate;
+                // 検索連番キー
+                frm.DataSearchSeqNo = m_SeqNo;
+
+                // 申請・承認レコード更新
+                if (!frm.ApprovalDataUpDate((int)CommonDefine.ApprovalStatus.Approval, false))
+                {
+                    MessageBox.Show("承認に失敗しました。", "承認エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 親フォーム終了
+                m_ParentEnd = true;
+
+                // 画面クローズ
+                this.Close();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 承認パネル（pnlApproval）保留ボタン押下処理
+        /// <summary>
+        /// 承認パネル（pnlApproval）保留ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void OnHoldProcess()
+        {
+            FrmApprovalPerson frm = new FrmApprovalPerson();
+            try
+            {
+                if (MessageBox.Show("協力会社申請登録を保留とします、よろしいですか？。", "保留確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.No) return;
+
+                // 一気にメニューに戻る
+                m_EndButton = true;
+                ClsExcute.ClearProcess();
+
+                // 担当者コード
+                frm.PersonCode = m_PersonCode;
+                // 承認機能番号セット
+                frm.ApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                // 受付日
+                string strartDate = m_dispControl[(int)DispCtrl.OrderDate].Text;
+                frm.OrderDate = CommonMotions.cnvDate(strartDate);
+                // 受付番号
+                frm.OrderNo = CommonMotions.cnvInt(m_dispControl[(int)DispCtrl.OrderNo].Text);
+
+                // 検索日付キー
+                frm.DataSearchDate = m_CreateDate;
+                // 検索連番キー
+                frm.DataSearchSeqNo = m_SeqNo;
+
+                // 申請・承認レコード更新
+                if (!frm.ApprovalDataUpDate((int)CommonDefine.ApprovalStatus.Pending, false))
+                {
+                    MessageBox.Show("保留に失敗しました。", "保留エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 親フォーム終了
+                m_ParentEnd = true;
+
+                // 画面クローズ
+                this.Close();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 承認パネル（pnlApproval）不承認ボタン押下処理
+        /// <summary>
+        /// 承認パネル（pnlApproval）不承認ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void NotApprovalProcess()
+        {
+            FrmApprovalPerson frm = new FrmApprovalPerson();
+            try
+            {
+                if (MessageBox.Show("協力会社申請登録を不承認します、よろしいですか？。", "不承認確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.No) return;
+
+                // 一気にメニューに戻る
+                m_EndButton = true;
+                ClsExcute.ClearProcess();
+
+                // 担当者コード
+                frm.PersonCode = m_PersonCode;
+                // 承認機能番号セット
+                frm.ApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                // 受付日
+                string strartDate = m_dispControl[(int)DispCtrl.OrderDate].Text;
+                frm.OrderDate = CommonMotions.cnvDate(strartDate);
+                // 受付番号
+                frm.OrderNo = CommonMotions.cnvInt(m_dispControl[(int)DispCtrl.OrderNo].Text);
+
+                // 検索日付キー
+                frm.DataSearchDate = m_CreateDate;
+                // 検索連番キー
+                frm.DataSearchSeqNo = m_SeqNo;
+
+                // 申請・承認レコード更新
+                if (!frm.ApprovalDataUpDate((int)CommonDefine.ApprovalStatus.NotApproval, false))
+                {
+                    MessageBox.Show("不承認に失敗しました。", "不承認エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 親フォーム終了
+                m_ParentEnd = true;
+
+                // 画面クローズ
+                this.Close();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 協力会社マスタ表示処理
+        /// <summary>
+        /// 協力会社マスタ表示処理
+        /// </summary>
+        private void DspOrderData()
+        {
+            try
+            {
+                // 表示されている時は再表示する
+                if (m_frm != null)
+                {
+                    m_frm.Activate();
+                    return;
+                }
+
+                m_frm = new FrmSubContractor();
+
+                m_frm.SubForm = true;
+                m_frm.EditLock = true;
+                m_frm.CompanyCode = m_SourceCode;
+
+                m_frm.ShowInTaskbar = true;
+
+                // クロースドハンドラをこちらで定義する
+                m_frm.FormClosed += new FormClosedEventHandler(FrmSubsonstrClosed);
+
+                m_frm.Show();
+
+                // データ表示
+                m_frm.DispReferenceData();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 協力会社マスタメンテナンス画面終了処理
+        /// <summary>
+        /// 協力会社マスタメンテナンス画面終了処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmSubsonstrClosed(object sender, FormClosedEventArgs e)
+        {
+            IOMSubContractor SubConstrDB = new IOMSubContractor();
+            try
+            {
+                // 参照時は引込処理をしない
+                if (m_EditLock) return;
+
+                // 終了ボタン押下で終了した場合
+                if (m_frm.EndButton) return;
+
+                this.Activate();
+
+                string strMsg = string.Empty;
+                // 選択無しは処理しない
+                if (m_frm.EndButton) return;
+
+                // データ置き換え確認
+                strMsg = "選択したマスタデータを取り込みますか？\n";
+                strMsg += "「はい」　を選択すると現在編集中のデータは破棄されます。\n";
+                strMsg += "「いいえ」を選択するとデータは取り込まれません。";
+                if (MessageBox.Show(strMsg, "データ読込確認", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
+                {
+                    string strSQL = SubConstrDB.CreatePrimarykeyString(m_frm.CompanyCode);
+                    SubContractorMaster subRec = new SubContractorMaster();
+                    if (!SubConstrDB.SelectAction(strSQL, ref subRec))
+                    {
+                        MessageBox.Show("協力会社マスタ読込に失敗しました。", "読込エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+                    // 読込マスタデータ表示
+                    DispMasterData(subRec);
+                    // 協力会社工種データ表示
+                    DspJobItemGrid(m_frm.CompanyCode, DateTime.Now, 0, false);
+                    // 協力会社職種データ表示
+                    DspdgvJobLinkGrid(m_frm.CompanyCode, DateTime.Now, 0, false);
+                }
+
+                if (radioButton4.Checked)
+                {
+                    // 新規時はデータクリア
+                    m_SourceCode = 0;
+                }
+                else
+                {
+                    // 修正時はデータ取得
+                    m_SourceCode = m_frm.CompanyCode;
+                }
+                this.Activate();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                m_frm.Dispose(); m_frm = null;
+                SubConstrDB.close(); SubConstrDB = null;
+            }
+        }
+        #endregion
+
+        #region マスタ読込データ表示
+        /// <summary>
+        /// マスタ読込データ表示
+        /// </summary>
+        /// <param name="SubRec"></param>
+        private void DispMasterData(SubContractorMaster SubRec)
+        {
+            try
+            {
+                // データ表示
+                switch(SubRec.CorporateStatusPoint){    // 法人格名称表示位置
+                    case 0:
+                        rdbPoint1.Checked = true;
+                        break;
+                    case 1:
+                        rdbPoint2.Checked = true;
+                        break;
+                    case  2: rdbPoint3.Checked = true;
+                        break;
+                }
+                m_dispControl[(int)DispCtrl.CorporateStatusName].Text = SubRec.CorporateStatusName;     // 法人格名称
+
+                m_dispControl[(int)DispCtrl.CompanyName].Text = SubRec.CompanyName;                     // 会社名１
+                m_dispControl[(int)DispCtrl.CEOPositionName].Text = SubRec.CEOPositionName;             // 役職名
+                m_dispControl[(int)DispCtrl.CEOName].Text = SubRec.CEOName;                             // 代表者氏名
+                m_dispControl[(int)DispCtrl.ContactPersonName].Text = SubRec.ContactPersonName;         // 窓口担当者
+                m_dispControl[(int)DispCtrl.ZipCode].Text = SubRec.ZipCode;                             // 郵便番号
+                m_dispControl[(int)DispCtrl.Address1].Text = SubRec.Address1;                           // 住所１
+                m_dispControl[(int)DispCtrl.Address2].Text = SubRec.Address2;                           // 住所２
+                m_dispControl[(int)DispCtrl.Address3].Text = SubRec.Address3;                           // 住所３
+                m_dispControl[(int)DispCtrl.CellPhoneNumber].Text = SubRec.CellPhoneNumber;             // 携帯電話番号
+                m_dispControl[(int)DispCtrl.MailAddress].Text = SubRec.MailAddress;                     // メールアドレス
+                m_dispControl[(int)DispCtrl.PhoneNumber].Text = SubRec.PhoneNumber;                     // 電話番号
+                m_dispControl[(int)DispCtrl.FaxNumber].Text = SubRec.FaxNumber;                         // FAX番号
+                m_dispControl[(int)DispCtrl.JapaneseSyllabary].Text = SubRec.JapaneseSyllabary;         // 50音読み
+                m_dispControl[(int)DispCtrl.Note].Text = SubRec.Note;                                   // 備考
+
+                switch (SubRec.labourKind)                                                              // 業者支払区分（通常・手間）
+                {
+                    case (int)CommonDefine.SubContractorPaymentKind.Normal:
+                        rdbPayment01.Checked = true;
+                        break;
+                    case (int)CommonDefine.SubContractorPaymentKind.Labor:
+                        rdbPayment02.Checked = true;
+                        break;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 施工工種を選択する画面を表示する
+        /// <summary>
+        /// 施工工種を選択する画面を表示する
+        /// </summary>
+        private void JobItemSelectFormDisplay()
+        {
+            FrmSubContractorItem frm = new FrmSubContractorItem();
+            try
+            {
+                frm.DialogUsed = true;
+
+                //frm.ShowInTaskbar = false;
+                frm.ShowDialog();
+                if (frm.EndButton) return;
+
+                List<KeyValuePair<int, string>> selectList = frm.SelectData;
+                int icurcnt = dgvJobItem.CurrentRow.Index;
+
+                // 追加行が表示行より多い場合は行を追加する
+                int iAddLine = dgvJobItem.Rows.Count - icurcnt;
+                if (selectList.Count >= iAddLine)
+                    dgvJobItem.RowCount += ((selectList.Count - iAddLine) + 1);
+
+                for (int i = 0; i < selectList.Count; i++)
+                {
+                    dgvJobItem.Rows[icurcnt + i].Cells[0].Value = selectList[i].Key;
+                    dgvJobItem.Rows[icurcnt + i].Cells[1].Value = selectList[i].Value;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose();
+                frm = null;
+            }
+
+        }
+        #endregion
+
+        #region 施工職種を選択する画面を表示する
+        /// <summary>
+        /// 施工職種を選択する画面を表示する
+        /// </summary>
+        private void JobLinkSelectFormDisplay()
+        {
+            FrmSubContractorJobCategory frm = new FrmSubContractorJobCategory();
+            try
+            {
+                frm.DialogUsed = true;
+
+                //frm.ShowInTaskbar = false;
+                frm.ShowDialog();
+                if (frm.EndButton) return;
+
+                List<KeyValuePair<int, string>> selectList = frm.SelectData;
+                int icurcnt = dgvJobLink.CurrentRow.Index;
+
+                // 追加行が表示行より多い場合は行を追加する
+                int iAddLine = dgvJobLink.Rows.Count - icurcnt;
+                if (selectList.Count >= iAddLine)
+                    dgvJobLink.RowCount += ((selectList.Count - iAddLine) + 1);
+
+                for (int i = 0; i < selectList.Count; i++)
+                {
+                    dgvJobLink.Rows[icurcnt + i].Cells[0].Value = selectList[i].Key;
+                    dgvJobLink.Rows[icurcnt + i].Cells[1].Value = selectList[i].Value;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        // -------------------- 印刷処理
+        #region 印刷時ボタン制御
+        /// <summary>
+        /// 印刷時ボタン制御
+        /// </summary>
+        /// <param name="bprint"></param>
+        private void PrintButtonVisbleControl(bool bprint)
+        {
+            panel1.Enabled = !bprint;
+            tableLayoutPanel1.Enabled = !bprint;
+
+            btnOtherProc.Visible = !bprint;
+            btnDataEntry.Visible = !bprint;
+            btnDataDelete.Visible = !bprint;
+            btnEnd.Visible = !bprint;
+
+            if (bprint)
+            {
+                btnPrint.Visible = false;
+                btnCancel.Visible = true;
+            }
+            else
+            {
+                btnPrint.Visible = true;
+                btnCancel.Visible = false;
+            }
+        }
+        #endregion
+
+        // -------------------- 印刷処理
+    }
+}
